"use strict";
exports.__esModule = true;
exports.ReactSCSS = void 0;

class ReactSCSS {
    compile = (styles, classes) =>
        classes.map(cls => styles[cls] || cls);

    compileEvents = (styles, events) =>
        Object.values(events).flatMap(eventObj =>
            Object.entries(eventObj).map(([state, value]) => styles[value] || value)
        );

    bind = (styles, opts = {}) => {
        const cls = opts.classes ? opts.classes.split(" ") : [];
        const dflts = opts.defaults ? opts.defaults.split(" ") : [];
        const evts = opts.events ? opts.events.split(" ") : [];
        const compiled = this.compile(styles, cls).join(" ");
        const compiledDefaults = this.compile(styles, dflts).join(" ");
        const compiledEvents = this.compileEvents(styles, evts).join(" ");
        return `${compiled} ${compiledDefaults} ${compiledEvents}`;
    }
}

exports.ReactSCSS = ReactSCSS;
module.exports = new ReactSCSS();